# MESS System Information Data File
# Maintained by Chris Henry
# Send corrections/submissions to: battlepriest@hotmail.com

# Thanks to Ben Bruscella, Juergen Buchmueller, JoJo Priore, and everyone on MESSDEV.
# Special Thanks to Thierry Schimbi!

# This file contains the basic documentation for most of the drivers presented in the MESS
# distribution. Please read the readme.txt, mess.txt and messnew.txt prior to reading this
# supplementary documentation.

# Driver entries are (usually) broken into three sections, Usage, Known Issues, and 
# History and Trivia.

# Usage - This section lists any helpful commands for the computer or console in question, 
# such as disk operating system and file loading BASIC commands. This information is not 
# intended to replace a proper owner's manual for the system in question, and only contains 
# the most simple commands that can also be found on any of dozens of websites devoted to 
# the system.

# Known Issues - This section lists any known problematic spots for the driver. These will be
# fixed as time and knowledge permit. Please be patient. If you have information that may
# help the MESS team resolve these issues, contact them at the addresses listed in MESS.TXT

# History and Trivia - This section contains various background pieces for a system. If you
# have anything you'd like to contribute contact me at the address above. Much of the 
# information in these sections was kindly provided by Thierry Schimbi of the "Museum of 
# Dead, Gone and Obsolete Computers". Visit it at:  http://www.computingmuseum.com


#---------------------------------------------------------------------------------------------#

$info=a5200
$bio
Atari 5200 SuperSystem


Known Issues:

Keyboard input is a little difficult, using a joystick or mouse is recommended.

Most games are playable. See a5200.crc for a fairly exhaustive compatibility list.


History and Trivia:

The Atari 5200 was introduced in 1982, and was actually designed to be a competitor to the 
Intellivision, before ColecoVision entered the market. Developed under the name of "Pam" 
(Atari, at the time, typically named projects after well-endowed female employees), Atari 
considered releasing it with that moniker; PAM in this case an acronym for "Personal Arcade 
Machine".


The 5200 shared much of the architecture of the Atari 400/800 computers, but featured a 
different cartridge connector and completely different controllers. Non-centering analogue 
joysticks which offered a full 360 degrees of mobility, were both innovative and unreliable. 
Other controller features included a keypad, and a ahead-of-it's-time pause button.


The Atari 5200 suffered from it's initial incompatability with the VCS/2600 (an adapter was 
later released) and fierce competition from Coleco. When Warner Communications sold Atari 
Corp. to the Tramiels in 1984, they quickly removed it from the market.


$end

#---------------------------------------------------------------------------------------------#

$info=a7800
$bio
Atari 7800 ProSystem


History and Trivia:

Originally developed in 1984 as the Atari 3600, the Atari 7800 Prosystem was released to the 
US market in 1986, in an attempt to compete in a revitalised home videogame market. The 7800 
was actually designed by Gencomp as part of a lawsuit settlement (Gencomp had been sued for 
releasing a speedup chipset for Atari Coinop Missile Command).


The 7800 was compatible with pre-existing Atari 2600 game program cartridges, without the need 
for expansion modules or turning switches, but was also designed to use enhanced 7800-only 
cartridges such as thepack-in "Pole Position 2". (n.b., only the 7800-specific cartridges are 
currently supported in MESS.) Many peripherals, including a computer/keyboard and high score 
saving cartridge were planned but never released.


Unfortunately for Atari, the system did poorly in the late 1980's market dominated by Nintendo.


www.atari-history.com has this interesting anecdote: "In the summer of 1984 the first 5,000 
Atari 7800's had just been built in the new El Paso assembly plant. The production line 
manager, Brad Saville was eager to meet with Jack Tramiel to show him the new flagship Atari 
video game console. The meeting ended abruptly as Jack Tramiel was quoted "Get your pollution 
out of here! We make computers now and we don't want your garbage." The line manager was fired 
2 days later. About 8-9 months later the line manager received a phone call from Atari asking 
him as to the whereabouts of the die molds for the Atari 7800. The ex-line manager responded 
that he did in fact know where they were and for $50/hour for about 200 to 300 hours of his 
time he would remember where they were and find them. The Atari Corp. representative who 
called was infuriated and informed the former production line manager that Atari's lawyers 
would be in contact with him. He never heard from Atari again."


$end

#---------------------------------------------------------------------------------------------#

$info=a800
$bio
Atari 800 Home Computer


Known Issues:

Requires full keyboard emulation. At startup, full keyboard emulation mode is enabled by 
default. Whilst in full keyboard emulation mode, some key associated functionality may be 
disabled (like the ESC key for EXIT). The keyboard emulation mode is toggled using the 
scroll_lock key.


The Atari800 driver now has two ROM slots. It really had two slots, so the code was modified 
to optionally read the second part of a 16K ROM from the second cartridge filename provided 
(right slot). The previous version had a800_cartridge_32k flag which was wrong. Cartridges 
are either 8K or 16K, so that was renamed to ..._16k too ;)


Most disk and cartridge images should work, though some graphic issues may exist.


The Atari 800XL driver (a800xl) is not currently working.


History and Trivia:

The Atari 400 and 800 were the first home computers to use custom coprocessors and the first 
to use "sprites" and special video interruptions like display lists, features that will be 
implemented several years after on the Commodore Amiga. It offered high graphic resolution, 
lots of colors and great sound capabilities, more than other computers could do then! The 
two models had same characteristics, the 400 is the low-cost version, it has only 16 KB 
(instead of 48 KB), one cartridge port (two for the 800) and a membrane keyboard (a 
typewriter style keyboard one for the 800). 


$end

#---------------------------------------------------------------------------------------------#

$info=advision
$bio
Entex Adventurevision


Known Issues:

Sound is not currently supported.

All four games are playable. 


History and Trivia:

The Adventure Vision was a cartridge based, electronic handheld video game that was 
manufactured by Entex Industries in 1982. It measured about 13 1/4" X 10" X 9" and used 
one vertical strip of 40 red LEDs and a spinning mirror to produce a screen with a 150X40 
resolution drawn at 15 frames/sec. There were only four cartridges produced for it: Defender, 
Turtles, Super Cobra, and an Asteroids clone, Space Force.


Visit http://www.adventurevision.com for more information.


$end

#---------------------------------------------------------------------------------------------#

$info=amiga
$bio
Commodore Amiga


Known Issues:

Sound is not currently supported.

The driver is now working fairly well, though some games may need more memory than currently
emulated.


History and Trivia:

The conceptor of the Amiga 1000 was Jay Miner, who created the Atari 800 many years before. 
He wanted to make the most powerful computer ever, then he joined a little California 
company called Amiga. He used the principle of the three coprocessors (again) to help the 
main processor. At the beginning, the Amiga had only 64 kilobytes of RAM!, Atari wanted to 
buy the Amiga but finally, Commodore succeded to buy it (then there was a lawsuit, which 
Commodore won). It was meant to be a competitor to the Atari 520 ST. The operating system 
was done by Metacomco, a British company who specialized in the 68000 processor (they also 
made languages for the Sinclair QL). It is a fully multitasking system which looks like 
UNIX with a graphical user interface. It was the very first personal computer with great 
graphics and sound capabilities with a GUI environment. The Amiga BASIC was written by 
Microsoft (like most other versions of BASIC). The Amiga 1000 began to lose popularity one 
year later with the creation of its two main successors: the Amiga 500 and the Amiga 2000.
There were two versions of the Amiga 1000. The first one, just called "Amiga", was sold 
only in USA, had a NTSC display, and didn't have the video modes EHB and HAM, later 
versions would have this built in. The second one, called "Amiga 1000" (to avoid confusion 
with its successor, the Amiga 2000) had a PAL display, the enhanced video modes 
(HAM & EHB) and was built in Germany.




$end

#---------------------------------------------------------------------------------------------#

$info=apple1
$bio
Apple 1


History and Trivia:

Steve Wozniak, who worked for Hewlett-Packard at the time, wanted to build his own computer. 
He couldn't afford the Intel 8080 CPU (this CPU was very popular then, as it was used in the 
Altair 8800 & IMSAI 8080, but was pretty expensive), he would use the Motorola 6800 but it 
was also much too expensive. Finally he decided to build his computer around the MOS 6502 
(which was pretty compatible with the Motorola 6800). The computer was easier to use than 
the Altair: unlike the Altair, the computer has a keyboard and can display characters on a 
TV (the Altair uses LEDs for its display). The display was very slow, only 60 characters (!) 
were displayed each second.


Steve Jobs, who made the game "Breakout" for Atari, with a little help from "the Woz", was 
interested in this computer. Together they created the Apple Computer Company and they tried 
to sell the computer. Paul Terrell, the owner of a computer shop, was interested in this 
computer, but fully assembled (the Apple 1 was sold "naked", no monitor, power supply, 
keyboard, tape drive, etc.) and with a cassette interface, which Wozniak designed. He sold 
it with the Basic he wrote soon after. They sold about two hundred of these units. This 
machine was so popular that Jack Tramiel of Commodore (!) offered to buy Apple, because 
Apple was, at the time, a major purchaser of MOS 6502 processors (Commodore owned Mos 
Technologies). Wozniak wanted $15,000 more than Tramiel offered, needless to say, the deal 
fell through. It was followed the next year by the Apple ][.


$end

#---------------------------------------------------------------------------------------------#

$info=apple2c
$bio
Apple //c Series


Known Issues:

Requires full keyboard emulation. At startup, full keyboard emulation mode is enabled by 
default. Whilst in full keyboard emulation mode, some key associated functionality may be 
disabled (like the ESC key for EXIT). The keyboard emulation mode is toggled using the 
scroll_lock key.

Many games and applications appear to be running now.


History and Trivia:

The Apple IIc is the compact (the "c" means compact) version of the Apple IIe. It has the 
same characteristics but lot of features which are optional on the IIe are provided on the 
IIc (floppy disk drive, 80 columns display, color display, 128 KB RAM), but unlike the 
Apple 2e, it has no expansion slots, so it is hard to add features to this computer. It 
runs either with DOS 3.3 either with ProDos and has the first version of QuickDraw in ROM. 
The Apple IIc was originally designed to be a portable version of the Apple II, but it 
wasn't a stand alone system, it has no batteries and no LCD screen (Apple would soon 
release the items), it coud also be used with a small 9" monochrome green screen which 
plugged into the unit. The Apple IIc was mainly used as a desktop computer. The Apple IIc 
was replaced with the Apple IIc+ in 1988.


The Apple IIc Plus unit was a direct response to the Laser 128EX/2.  Apple retrofitted the 
IIc design to try to compete with Video Technology's high speed Apple II clone. The 
retrofitting is evident in the design of the motherboard.  The motherboard runs at 1Mhz, 
unlike the Laser 128EX/2.  In order to run its programs faster, Apple used a 4Mhz 65C02 
with 8k of high speed SRAM cache and licensed the accelerator design from Zip 
Technologies (makers of the ZipChip accelerator for the IIe and IIc).  They built an 
accelerator into a 1Mhz motherboard rather than design a faster motherboard from scratch.


The designers of the Apple IIc Plus originally wanted to make a portable IIGS. Apple's 
management, bent on promoting the Mac, balked at the idea. At the same time, the 
Laser 128EX/2 made a quick design cycle mandatory. The result is an updated IIc.


The Apple IIc Plus was the finest Apple 8-bit computer ever built, but lack of marketing, 
the apparent de-evolution in technology compared to the 16-bit Apple IIGS, and the 
aggressive sale of the Laser 128EX/2 made the IIc Plus the most short lived of the 
Apple II models.


$end

#---------------------------------------------------------------------------------------------#

$info=apple2e
$bio
Apple //e series


Known Issues:

Requires full keyboard emulation. At startup, full keyboard emulation mode is enabled by 
default. Whilst in full keyboard emulation mode, some key associated functionality may be 
disabled (like the ESC key for EXIT). The keyboard emulation mode is toggled using the 
scroll_lock key.


Many games and applications appear to be running now.


History and Trivia:

The Apple IIe is the successor of the Apple II+. It was a very great success and was widely 
used in schools (and it's still used today in some places !). It works under DOS 3.3 
(the Apple II operating system) and uses 143 KB floppy disks.


The Apple IIe was replaced with the Apple IIe+, which had an enhanced keyboard, a 4 MHz 
65C02 CPU and a 3.5" floppy disk unit.


$end

#---------------------------------------------------------------------------------------------#

$info=astrocde
$bio
Bally Professional Arcade/Astrocade


Usage:

Loading the Astrocade driver without a cassetridge image will allow you to use the four
built-in programs.


Known Issues:

To the best of our knowledge, full compatibility, aside from Bally Basic tape support.


History and Trivia:

The game console commonly known as the "Bally Astrocade" was never officially sold by that 
name, having originally been released by Bally Manufacturing in 1978 as the Bally Professional 
Arcade. It was withdrawn rather quickly though, due to the success of the competing Atari VCS. 
A group of Pro Arcade enthusiasts under the name Astrovision Inc., bought the rights to the 
Pro Arcade and reintroduced it as the Bally Computer System, including the Basic casettrige as 
a pack-in. In 1982, the system and company was renamed Astrocade, once again trying to market 
it as a video game system. The system didn't last much longer, though; it was a product with a 
limited interest base even before the video game slump of the next few years.


$end

#---------------------------------------------------------------------------------------------#

$info=c16
$bio
Commodore C16, Plus 4, and C364


Cassette Usage:

Cassette images can have the .wav or .prg extensions, and multiple .prg files 
can be contained within a zip file. Zip files must be placed in the current directory, and 
the contained prg files are played in sequential order.


The format for WAVs are: 
8 bit (16 bit may work, but this hasn't been tested), mono, 12500 Hz minimum. This has the 
same problems as an original Datasette tape drive (the tone head must be adjusted to get 
working (no load error...) wav-files)


Note that tape volume is DAC1 volume within the MESS UI On Screen Display Options (accessed
with the tilde (~) key in the DOS version.


Within the emulation, use LOAD or LOAD"" or LOAD"",1 for loading normal programs. Use 
LOAD"",1,1 for loading programs to a special address.


Diskette Usage:

Disk drives are simulated at the moment, and only file loads from drive 8 and 9 
are implemented. You can load a program file from the rom directory (*.prg,*.p00)
(This must NOT be specified on commandline, start the c16 emulation with no images specified)


The directory command LOAD"$",8 is supported when using d64 images.



Within the emulation, basic programs can be loaded with: 


DLOAD"filename" or LOAD"filename",8 



Machine language programs can be loaded to their address with: 


DLOAD"filename" or LOAD"filename",8,1


When a program is loaded, type RUN or the appropriate SYS call to start it. 


Note that several programs rely on more features not currently emulated (such as 
loading other file types, writing...) Some games also rely on starting programs in the 
floppy drive's proccessor (and therefore cpu level emulation of the 1541 is needed).


Cartridge Usage:

Cartridges may have any of the following extensions: .bin .rom .lo .hi .prg
Files with boot-sign in it are recognised as roms. Some cartridges require more than one 
image to load (e.g., tutor.lo tutor.hi).


 
.prg files loaded at address in its first two bytes


 
.bin, .rom, .lo , .hi roms are loaded to cs1 low, cs1 high, cs2 low, cs2 high addresses 
accordingly to their order in the command line.


 
Note that .prg and .p00 files are assigned to the quickloader (so you have to use 
the -cart switch when loading rom images).


Quickloader Usage:

A quickloader is available via the f8 key. It supports program image files 
with the .prg extension. This loads the program into memory and sets the program end 
pointer. It works with most programs. The program can be started by entering "RUN" in 
the emulation.


Miscellaneous Usage Notes:

See "Keys (This Machine)" for key assignments.

Shift-cbm switches between upper-only and normal character set (if wrong characters are on 
screen this may help).

Run (shift-stop) loads the first program from device 8 (dload"*) and starts it.

If you run into difficulty, be sure to start the emulation with the -log switch, and look into
the error.log file that is created in your mess directory.


Known Issues:

Memory check by c16 kernel will not recognize more memory without restarting MESS.

CPU clock switching/changing.

Imperfect colors; should be enough for 95% of the games and programs.

Imperfect scrolling support (when 40 columns or 25 lines)

Lightpen support missing.

Some PC-Keyboards do not behave well when special two or more keys are pressed at the same 
time (with my keyboard printscreen clears the pressed pause key!)

Expansion modules other than the 1551 floppy drive are not supported.

The rs232/v.24 interface is not supported, nor are printers and other parallel devices.

The Plus 4's userport is not supported.

Note if a game runs too fast with the ntsc version, try the pal version!


The following features are emulated:

	- rasterline based video system

	- keyboard, joystick 1 and 2

	- simple tape support

	- serial bus

	- simple disk drives

	- expansion modules

	- rom cartridges

	- simple ieee488 floppy support (c1551 floppy disk drive)

	- quickloader


History and Trivia:

When the first Commodore 264 prototype unofficially debuted at the Winter Consumer 
Electronics Show (CES) in January (?) 1984, the developers had obviously not yet agreed 
about the keyboard layout; some keys are unlabelled, the right shift key was missing, 
instead having a key which seems to be meant as a line feed key.

 
It was planned that when buying a C264, you could have chosen between these programs: 

	- 3 plus 1 (word processor, data base, spread sheet, windowing) 

	- Superscript (professional word processor) 

	- Magic Desk (word processor, data base, spread sheet, calculator) 

	- Logo 

	- Pilot 

	- Easycalc 264 (spread sheet) 

	- COM 264 

	- Financial Advisor 


 
The C264 should then be delivered with the selected program built in. The remaining programs 
could only be used with cartridges for the expansion port.


 
The official presentation of the C264 series took place on the Hannover fair in 1984. 
Luckily, the developers didn't eliminate the right shift key in the final keyboard layout. 
The formerly unlabelled keys bear a label now: the key that used to be the left arrow 
key on the C64 and the VC20 says 'Esc', the key between '@' and '*' bears the English pound 
sign, and the key that was labelled 'SHIFT LOCK' on all 8-bit computers Commodore ever 
produced now says - guess what - 'SHIFT LOCK' :-) (must have been a hard decision between 
SHIFT and CAPS lock).


 
A word about the C364 : This prototype was a C264 with a bigger keyboard (86 keys incl. a 
numeric keypad) and with a builtin speech synthesizer with a vocabulary of 250 words (which 
could be expanded by either diskettes or modules). Commodore dropped this model and decided 
to sell a separate speech module (Magic Voice) for the C64.


 
Among the Commodore news from the Summer CES 1984 was the renaming of the C264 to Plus/4. 
This renaming came along with a slight change in the builtin software: you could not choose 
between many different programs anymore, but each Plus/4 was delivered with the 3-plus-1 
software.


 
The built-in software was really limited: a word processing (only with 40 columns and can 
manage documents with only 99 lines of 77 columns), a very small spreadsheet (only 17 
columns and 50 lines), a poor graphic software (which can display graphically datas from 
the sheets but only in text mode) and a small database (999 record with 17 fields each 
and only 38 characters by field). Most of these programs can only be used with a floppy 
disk unit. The Plus 4 can use peripherals of the C64 or the Vic 20, the printer MPS801 
and the Disk Unit 1541 run well with it but it can't use C64 softwares. This machine 
wasn't built to be a competitor of the C64 nor to replace it. It has an improved basic 
in relation to the C64 one with graphic and sound instructions and a built-in assembler, 
but has lost lots of interesting C64 features like great soundchip or hardware sprites. 


 
The Commodore 16/116 belongs to the Commodore 264 series (with the Commodore Plus/4). It was 
designed to replace the Commodore VIC-20, but was not compatible with it, nor with 
the C64. It had the same characteristics as the Commodore Plus/4 : same graphic resolution, 
same sound system, same CPU and speed, just less memory. It has a powerful basic language 
(contrary to the VIC-20 or the C64) which makes graphics and sounds easy to program. 
The C16, like the Commodore Plus/4 was a commercial failure.


 
The C116 was an earlier version of the C16 and had a rubber keyboard. It was sold in Austria, 
at least, and perhaps in other countries as well.


 
It seems that the first C16s had the two control ports labelled JOY 0 and JOY 1 instead of 
JOY 1 and JOY 2, just as a hint for collectors :-)


 
Note that like the C116, the C16 lacks a user port.


$end

#---------------------------------------------------------------------------------------------#

$info=c64
$bio
Commodore 64


Diskette Usage:

Disk drives are simulated at the moment, and only file loads from drive 8 and 9 
are implemented. You can load a program file from the rom directory (*.prg,*.p00)
You can also load a file from a d64 image (The directory command LOAD"$",8 is supported when 
using d64 images).


 
Within the emulation, basic programs can be loaded with:  LOAD"filename",8 


 
Machine language programs can be loaded to their address with:  LOAD"filename",8,1


 
When a program is loaded, type RUN or the appropriate SYS call to start it. 


 
Note that several programs rely on more features not currently emulated (such as 
loading other file types, writing...) Some games also rely on starting programs in the 
floppy drive's proccessor (and therefore cpu level emulation of the 1541 is needed).


Cartridge Usage:

Cartridges may have any of the following extensions: .prg .crt .80 .90 .a0 .b0 
.e0 .f0   Files with boot-sign in it are recognised as roms. Some cartridges may require more 
than one image.

 
.prg files loaded at address in its first two bytes

 
.?0 files are loaded to the address specified in the extension.

 
.crt roms are loaded to the addresses specified in crt file.


 
Note that .prg files are assigned to the quickloader (so you have to use 
the -cart switch when loading rom images).


Cassette Usage:

Cassette images with the .wav or .prg extensions as well as multiple .prg files 
contained within a zip file can be loaded. Zip files must be placed in the current directory, 
and the contained prg files are played in sequential order.


 
The format for WAVs are: 
8 bit (16 bit may work, but hasn't been tested), mono, 12500 Hz minimum. This has the same 
problems as an original Datasette tape drive (the tone head must be adjusted to get working 
(no load error...) wav-files)


 
Note that tape volume is DAC1 volume within the MESS UI On Screen Display Options (accessed
with the tilde (~) key in the DOS version.


 
Within the emulation, use LOAD or LOAD"" or LOAD"",1 for loading normal programs. Use 
LOAD"",1,1 for loading programs to a special address.


Quickloader Usage:

A quickloader is available via the f8 key. It supports program image files with 
the .prg and .p00 extensions. This loads the program into memory and sets the program end 
pointer. It works with most programs. The program can be started by entering "RUN" in the 
emulation.


Miscellaneous Usage Notes:

Gameport A supports paddles 1 & 2,  joystick 1, lightpen (implementation not finished).

Gameport B supports paddles 3 & 4, joystick 2

If you run into difficulty, be sure to start the emulation with the -log switch, and look into
the error.log file that is created in your mess directory.

If the game runs to fast with the ntsc version, try the pal version! (c64pal)


Known Issues:

The rasterline based video system currently has the following issues: no cpu holding, imperfect 
scrolling support (when 40 columns or 25 lines), lightpen support not finished, rasterline not 
finished.

Sound is not currently supported

The restore key is not currently working.

NTSC/PAL select not correct.

The Gameports do not suport the mouse (Serial Protocol?).

No printer or other devices support in the serial bus (apart from simple disk drives).

Simple tape support not working (cia timing?)

As far as expansion modules go, non-bankswitching rom cartridges (exrom) should work, but no 
other rom cartridges (those with bankswitching logic in it, switching exrom, game). There is 
no ieee488 support nor support for other expansion modules.

No userport support and no rs232/v.24 interface.

 
Some issues with the cia6526: 

	- port a,b

	- handshake support, flag input, not pc output

	- no serial in/out, cnt

	- timer a,b

	- not counting of external clocks

	- not switching port b pins


History and Trivia:
 
Designed similar to the Vic-20, the Commodore 64 featured a better video chip supporting 
sprites, as well as the famous sid6581 sound chip, two "Atari-compatible" joystick ports,
and 64 kilobytes of RAM.


 
The Commodore 64 is, along with the Apple II and the Atari 8-Bit computers, one of the 
most famous home computers of it's era. During its production from 1982 to 1993 (!) 17 
to 22 million (!) of these computer would sell, to put in perspective, that's more than 
all the Macintoshes in the world. It was one of the first to offer a high quality sound 
chip and graphic resolution with many colors and sprites. A great range of peripherals 
was developped for this computer and can use several of the Vic 20 peripherals. 


 
Several versions of the Commodore 64 were launched : The first one (C64-1) uses the VIC 20 
case, it will be quiclky replaced with the C64-2 which uses the famous brown case and by 
the C64-3 with small cosmetic changes in the keyboard. A special version called Educator 64 
or PET64 or CBM 4064 was proposed for schools and uses the PET case.


 
Commodore produced the first generation of C64s until May 1986, then it was discontinued 
and they introduced the C64C. According to the 64'er magazine, this version has been 
planned since the Hannover mass in 1985, but as the old version sold so well during 
Christmas '85, its release date was pushed back.


 
The new model does not differ much from its predecessor, the only innovation is the 
flatter case, which makes the keyboard (which has off-white keys now) more ergonomical 
(it looks like the C128 case), as it is less higher than the old one. But the new case 
did not only have advantages: due to its low profile and additional metal screening, 
some of the numerous hardware expansions did not fit anymore. This was changed with 
the C64G. The 64'er staff noticed that VIC-II as well as the two CIAs have new version 
numbers; they didn't write which, though (these are probably just bugfixed chips). 


 
The official name for this model was "C=64 C", but nevertheless the German 64'er magazine 
decided to call it "C64-II" (because the first units didn't have the new name on the label 
at the bottom), the badges on all the 64 C's just says "Commodore 64". They pointed out 
that this name was only valid for the 64'er magazine, but since the 64'er was the 
magazine for the C64 for a long time, the name was widely accepted and so this model 
is mostly known as "C64-II" in Germany.


 
The C64C appeared again after (or concurrently with?) the C64G, this time with the new, 
short board. So, although the case might look the same and the label says "Commodore 64", 
the boards may be completely different.


 
Commodore also released a "laptop version" (though hardly portable) of the C64, called SX64. 
This computer has a built-in 5" color screen, one detachable keyboard, one 5.25" floppy 
disk drive (the famous 1541) and a second one can be installed as well. A version called 
DX-64 was launched (in very limited quantities) at the same time, it has same 
characteristics as the SX64 except its two 5.25" floppy disk drives. The SX64 and DX64 
computers never had success, but it is known as the world's first color portable.


 
The C64GS was released in 1990. Basically it was a re-boxed C64, without a keyboard or any 
other interfaces, except for the cartridge slot on top. It didn't have much success as you 
could buy a C64 for not much extra, and the C64GS games would still work on the C64.
It came with one game cartridge containing International Soccer, Klax, Flimbo's Quest
and Fiendish Freddy's Big Top O'Fun. The carts had a memory of 4 megabits (512k).



$end

#---------------------------------------------------------------------------------------------#

$info=cbm500
$bio
Commodore CBM 500 Series


History and Trivia:

The 500 / 600 / 700 series were mainly sold in Europe, but a few models are known to have been 
sold in the United States. The CBM 600 is same as the 500 but has a 80 column display and 
256 Kb RAM. The CBM 700 is same as the 600 but has two 5.25" disk drives (370 KB each) and a 
hard disk (7.5 MB). Microsoft Basic is in ROM. The Z80 and the 8088 are optional. When they 
are used, the 6809 is used then for i/o, display and keyboard management. It works under 
Commodore DOS or CP/M and MSDOS when the computer use the other processors. 



$end

#---------------------------------------------------------------------------------------------#

$info=cpc6128
$bio
Amstrad/Schneider CPC 6128


Usage:

With a disk image loaded, the emulation starts from the BASIC "Ready" prompt. 
From here you can enter commands to access the disk image: 
 

A directory listing can be obtained with: "CAT"


A program can be run with: RUN"filename"


The common programs to run are those with a .BIN or .BAS extension and usually the smaller 
of the files on the disk image.


On a few games you can type: RUN"disc or RUN"disk to start the game.


If a directory listing cannot be obtained, then the disc might be copy-protected. 
In this case, try: 

|CPM


| is obtained by pressing shift and the @ key together. Since the keyboard is mapped so the 
keys are in the roughly same place as on a real Amstrad keyboard, then @ can be found 
around the [,@,],# keys.

The |CPM works by loading and executing the first sector on the first track of the disc.


Snapshots, which contain a memory dump, cpu state and hardware state, can be run from a 
command line interface with the following command: 

mess cpc6128 -snap "snapshot name"


The snapshot will start automatically.


Known Issues:

Requires full keyboard emulation. At startup, full keyboard emulation mode is enabled by 
default.  Whilst in full keyboard emulation mode, some key associated functionality may be 
disabled (like the ESC key for EXIT). The keyboard emulation mode is toggled using the 
scroll_lock key.   

Runs many disk images and snapshots well.


History and Trivia:

The CPC6128 was a 8-bit Amstrad computer, produced in 1985. The computer was sold with a 
colour monitor or a green screen monitor. This connected to a keyboard unit which had a 3" 
drive in it. The monitor contained the power supply for the computer. Using this arrangement 
only a single plug was required. The CPC6128 was the third in the CPC series. It had the same 
hardware as the CPC464 and the CPC664.


CPC464: 64k of ram, tape recorder built in.

CPC664: 64k of ram, 3" disk drive built in

CPC6128: 128k of ram, 3" disk drive built in.


The Amstrad had a Z80 at it's core. It had a palette of 27 colours, produced from combinations 
of 3 levels of r,g and b. It has three graphics modes. 640x200 in 2 colours (hi-res), 320x200 
in 4 colours (medium res), 160x200 in 16 colours (lo-res).


$end


#---------------------------------------------------------------------------------------------#

$info=cgenie
$bio
EACA Colour Genie 2000


Cassette Usage:

From within the emulation you can use SYSTEM or CLOAD commands to read images: 

SYSTEM supports 6 character filenames.

CLOAD loads a file named BASIC(N).CAS, where (N) is the character you supplied 
(e.g., CLOAD"M" loads BASICM.CAS)

CLOAD is for BASIC type tapes only.  It should work if you have a BASIC *.cas file. 
File "names" in that case are _one_ character in length (inside the emulation).  In your 
roms/cgenie folder the names will be basicA.cas, basicB.cas and so on.  If you CSAVE"A you'll 
see a file basicA.cas later and you can CLOAD"A it again. 


To load a binary image there was a different command: SYSTEM

You'll see a prompt looking like this: 

*?


and there you can enter a name of up to six (wow!) characters.

*?chop16 [ENTER]

This will start loading a file named chop16.cas if it is in your rompath. If you don't have 
it... well, wait and see (nothing ;)  If you have it, you'll see two stars (**) in the upper 
right corner.  The right one will twinkle after every couple of bytes loaded, every 254 I 
think.
	
After several minutes you'll see the prompt again

*?


now type / (slash) and ENTER and the program will be started at it's defined run address. If 
a program does not have a run address, you could also specify /[decimal value] to run from a 
specific value...


 
Diskette Usage:

When the emulation starts, tap [ENTER] and also confirm the following 
	
MEM SIZE?

with [ENTER].

After that you're in BASIC (DISK BASIC, to be exact, unless you disable cgdos.rom via the 
dip switches).

Now you can use the DISK BASIC extensions to issue commands.  Most important

CMD"I[disk#] 

Display inventory, disk# is optional and can be from 0 to 3

You can use CMD"I0" to "CMDI3" to get an inventory of drive 0 to 3.


Use CMD"S FILENAME/CMD" to start a binary executable or use LOAD"FILENAME/BAS" to load a basic 
program.
CMD"Sname/cmd will start a binary file name/cmd from any disk

CMD"Limage/bin:3 will load image/bin from disk 3

To start a game, eg. paint/cmd, type

cmd"s paint/cmd


You can omit the blank between cmd"s and the filename.


To ease things you could also enable my DOS lookalike frontend ;) It's contained in 
newe000.rom (2,772 bytes; CRC 953491a7) but not enabled by default. If you enable it 
you can type HELP (hehe ;) and DIR and simply give a name to execute a binary file.

The optional newe000.rom is loaded if the corresponding "dip switch" is set from within the 
driver itself. There is no need to specify this rom on the commandline.


Miscellaneous Usage Notes:
 
Under the "Options" menu, accessible by hitting TAB, there are three settings: 

"Floppy Disc Drives"  - enable or disable floppy disc controller.

"DOS ROM C000-DFFF"   - enable 8K DOS ROM or make it RAM.

"EXT ROM E000-EFFF"   - enable 4K Extension ROM or make it RAM.


Known issues:

Startup with CAS or CMD images does not always work. Use the BASIC SYSTEM or CLOAD commands 
to read cassette image files, or use the Colour Genie DOS ROM with floppy disc images to run 
programs. The driver does not yet emulate the printer port mode for AY-3-8910. Right now it 
always uses the AY-3-8910 ports for joystick emulation.


Requires full keyboard emulation. At startup, full keyboard emulation mode is enabled by 
default.  Whilst in full keyboard emulation mode, some key associated functionality may be 
disabled (like the ESC key for EXIT). The keyboard emulation mode is toggled using the 
scroll_lock key.   


The Colour Genie driver should run most of the known programs out there. It supports the 
Motorola 6845 CRT controller with text and graphics modes (LGR and FGR), the AY-3-8910 
sound chip with three audio channels and noise and the WD 179x floppy disc controller with up 
to four virtual floppy disc drives contained in image files.


The keyboard is relatively close to the original layout; see "Keys (This Machine)" in the
TAB/Options menu.


Emulation of dual Colour Genie joysticks with keypads is also supported.


History and Trivia:

The Colour Genie is the successor of the Genie 1, Genie 2 and Genie 3. It is not possible 
to mix characters and graphics because text and graphic memories are not mixed. There was 
a little level display located above the keyboard which allows to set the recording 
level of the tape recorder to avoid failure when writing onto a tape. 



$end

#---------------------------------------------------------------------------------------------#

$info=coco
$bio
Tandy/Radio Shack Color Computer / Dragon Data Ltd. Dragon 32


Known Issues:

Requires full keyboard emulation. At startup, full keyboard emulation mode is enabled by 
default. Whilst in full keyboard emulation mode, some key associated functionality may be 
disabled (like the ESC key for EXIT). The keyboard emulation mode is toggled using the 
scroll_lock key.


History and Trivia:

The Tandy TRS 80 color computer was typically called 'coco'. It was compatible with the 
Welsh Dragon 32: they can use same softwares and cartridges. Unlike the Dragon, though, it 
used its own basic, Tandy Basic instead of the Microsoft basic. It was followed by the 
TRS 80 color computer II.


The TRS 80 color model II (coco2) replaced the model I in 1983. It has the same 
characteristics than the Model 1. It has 16 KB RAM and can have a 16 KB ROM which contains 
Microsoft Basic. It was replaced with the TRS80 color model III in 1986. 


The Tandy TRS 80 Color Computer III is the successor of the TRS 80 Color Computer II. It can 
work with OS-9 (an operating system designed for 6809 processors). As this processor is an 8 
bit (strange choice when Atari and Commodore were using a 68000), it can't access 
simultaneously to the 128 KB (or 512 KB), it uses several RAM banks (as the Thomson TO8, or 
MSX 2 computers) which can be switched. 


Tandy made several prototypes of a TRS 80 color model IV but it was never released. The 
DRAGON 32 enjoyed a pretty good success in Europe. Its ROM holds the Operating System and a 
BASIC programming language by Microsoft. One of its characteristics is partial compatibility 
with the Tandy TRS 80 Color Computer Series: they can use same peripherals and some 
cartridges. Two years later, Welsh launched the DRAGON 64 which has the same 
characteristics except the added memory (64 KB instead of 32 KB), a RS232c port and a keyboard 
with repetitive keys.



$end

#---------------------------------------------------------------------------------------------#

$info=coleco
$bio
Coleco Industries ColecoVision


Known Issues:

This emulation runs most cartridges accurately. Games requiring analogue controls (Steering 
Wheel, Roller Controller) are not playable. See coleco.crc for further compatibility notes.


History and Trivia:

The ColecoVision video game system was released in August of 1982 for a suggested retail 
price of $175 US. Similar at it's core to the MSX computers, ColecoVision had both superior 
graphics and more expansion capabilities compared to it's chief rivals: the Atari 2600 and 
Intellivision. Among the expansion module options were a hardware Atari 2600 emulator, and a 
Steering Wheel for driving games, both unheard of at the time.


The competitive price, technical superiority, and perhaps more importantly, the inclusion of 
Donkey Kong as the pack-in cartridge, led to Coleco becoming an industry leader. With the 
emergence of the popularity of home computers, however, the console market seemed in jeopardy 
of losing it's share to the likes of Commodore and Apple. Coleco responded by releasing the 
Adam Family Computer as both a standalone unit and as an expansion to the ColecoVision itself. 


The Adam was a phenomenal market failure though, and Coleco pulled itself from both the 
console and computer markets just before the game market crash in late 1984.


Telegames purchased the rights to the system, and many of the manufactured games, and released 
a clone, The Personal Arcade, in 1988. It was later re-released by them, as the DINA.


$end

#---------------------------------------------------------------------------------------------#

$info=ep128
$bio
Enterprise 128


Usage:

This computer has a built in word processor, from BASIC enter "type" to enter it.

To load programs:

You can type ":EXDOS" to enter a CLI interface where you can type EXDOS commands.
If typing from BASIC you must enter ":" in front of EXDOS commands.

The following EXDOS commands are allowed:

CHDIR	[dir name]
		- Change Dir.[dir name] does not need to be enclosed in quotes.
DIR		
		- show directory listing

To run a program, enter from BASIC:

RUN"filename" or

LOAD"filename"


Known Issues:

Requires full keyboard emulation. At startup, full keyboard emulation mode is enabled by 
default. Whilst in full keyboard emulation mode, some key associated functionality may be 
disabled (like the ESC key for EXIT). The keyboard emulation mode is toggled using the 
scroll_lock key.

Some programs do not work well.

Not all graphic modes are emulated.

Interrupts are not emulated correctly.

Sound is not supported.

Tapes are not supported.


History and Trivia:

The Enterprise 64 was a very long-awaited computer, two years between its announce and 
its marketing ! It changed its name a lot of times : its first name was Elan 64, then 
Flan, lastly Enterprise. It has great features, which wasn't found on all other home 
computers like its interfaces and its great graphics and sounds capacities provided by 
two special custom chips called "Nick" and "Dave". The Basic is supplied on a ROM 
cartridge and can be easily replaced with an other language. This basic is a very 
powerful structured basic with great graphic commands and can store several programs 
simultaneously in RAM. It has a small word processing in ROM and up to 32 computers can 
be linked together. Despite its great characteristics and all its interfaces, the 
Enterprise 64 had few success. Several months later, a new model was launched : the 
Enterprise 128 which is an Enterprise 64 with 128 KB RAM. 


$end

#---------------------------------------------------------------------------------------------#

$info=gameboy
$bio
Nintendo GameBoy


Known Issues:

Input is broken in several games.

Sound is not yet supported.


History and Trivia:

The best selling video game system of all time.



$end

#---------------------------------------------------------------------------------------------#

$info=genesis
$bio
Sega Megadrive/Genesis


Usage:

Under the "Options" menu, accessible by hitting TAB, you will find the following option: 


"Country" - this allows you to alter the 'flavour' of Genesis, to either European, Japanese 
or American. Many cartridges compare their country codes with that of the Genesis itself and 
may behave differently, or lock up if the two types do not match.


'Auto' attempts to auto-set the Genesis country code to the value the cartridge will appear 
to be checking for. This may not be 100% accurate, however.


Known Issues:

Most games tend to run fairly well. Some have slight graphic glitches, incorrect colours part 
way down the screen or other bizarre effects. See genesis.crc for a partial list.


Cartridges up to 32MBit (4MByte) are supported.


The controller may not work well with some games. This will be resolved when more information 
is obtained. Similarly, 6-button joypads aren't emulated yet.


Split screen effects and interlacing are not yet supported.


Sprite/layer priority should be perfect.


Sound is emulated at Z80 and PSG76489 level. 


I still consider the Genesis driver extremely preliminary. I have a lot of further work to do 
before I consider it anywhere near complete. My initial goal is to make it as compatible as 
possible. Currently there is scope within the driver to handlesplit screen colour changes/any 
VDP effect, interlacing, without rewriting. The graphics renderer emulates VDP at scanline 
level, and does not use tile-based methods.


Wanted: Any Sega Megadrive information! Information is extremely sparse; typically the same 
three-four documents, with parts incomplete, conflicting, and corrupted. Specifically, some 
of the finer points of DMA transfer, and access of the 68K memory map by the Z80. Generally, 
points which conflict with themselves in the documentation available on the net...



$end

#---------------------------------------------------------------------------------------------#

$info=kaypro
$bio
Kaypro IIx (kaypro)


Known Issues:

Requires full keyboard emulation. At startup, full keyboard emulation mode is enabled by 
default. Whilst in full keyboard emulation mode, some key associated functionality may be 
disabled (like the ESC key for EXIT). The keyboard emulation mode is toggled using the 
scroll_lock key.


Problems with the conversion to the MAME core....  Emulation OK....  


$end

#---------------------------------------------------------------------------------------------#

$info=kccomp
$bio
KC Compact (kccomp)


Usage:

Image loading is the same as for the Amstrad CPC series.

At this time the driver doesn't support loading from disk images. I don't
know if a disc interface was designed for this computer.
However, snapshots will work.


Known Issues:

Requires full keyboard emulation. At startup, full keyboard emulation mode is enabled by 
default. Whilst in full keyboard emulation mode, some key associated functionality may be 
disabled (like the ESC key for EXIT). The keyboard emulation mode is toggled using the 
scroll_lock key.


History and Trivia:

The KC Compact is a copy of the Amstrad CPC series, made in East Germany
around 1985 just before the Berlin wall came down.
The system contains a hacked Amstrad CPC 6128 Operating System and the
Amstrad CPC 6128 BASIC. Unlike the CPC, this
system didn't come with a built in disc drive or cassette unit, and did not
require a special monitor. Not many of these systems were produced.


The Amstrad CPC had a gate array chip which contained the logic for the
palette, mode display, rom paging,ram paging and interrupt
system. This is emulated in the KC Compact using a lot of TTL logic chips
and a Zilog 8536 chip.


Hardware that was designed for the CPC systems should work on the KC
Compact, however, since the KC Compact has a different
expansion port layout, a adaptor must be made.


The KC Compact interrupt system is driven by a counter inside the Zilog
8536. This counts HSYNC transitions and decrements a counter.
The count is reset by a VSYNC. What this means is that the interrupt system
is slightly different to the CPC, and so any programs which
rely on exact interrupt behavior will not work as expected.


What is interesting though, is that since the counter in the 8536 can be
re-programmed, interrupt frequency can be changed. The KC
therefore has a superior interrupt system compared to the CPC. The 8536 has
two other counters, which from the schematics, appear
to be connected to the video hardware. This could mean that different
resolutions could be generated, but this is not confirmed yet.


$end

#---------------------------------------------------------------------------------------------#

$info=kim1
$bio
Commodore/MOS Kim-1


Usage:

key   name  description

-----------------------

F1     AD    address mode

F2     DA    data mode

F3     RS    reset

F5     GO    execute from address

F6     PC    program counter (hmm.. whatever)

F7	 ST    step (note: NMI handling for K7 missing)

ENTER  +     increase address

0-F    hex   hex digits


Known Issues:

This driver supports the backdrop image of the KIM-1, and code images in .kim format.



$end

#---------------------------------------------------------------------------------------------#

$info=laser210
$bio
Laser 210 Series/Dick Smith VZ-200

Usage:

Basic programs start with RUN.

Other programs usually start with X=USR(0)

X=USR(0) can be typed out with the following PC keystrokes: x, shift -, u, s, r, shift 8, 0, 
shift 9, enter.


History and Trivia:

The laser 200 was the successor of the Laser 100/110 (which had only monochrome graphic 
modes).


Adman Harbison says "The Video Technology Laser 200 (and the Laser 300) were marketed in 
Australia by Dick Smith Electronics and badged as the VZ200 and the VZ300 computers.  
For memory the computers were exactly the same, although he can not be too sure.  
Some of the peripherals that I got while I had such a machine were things like a 16Kb 
expansion cartridge, a printer/plotter which wasn't much bigger than those little 
calculators that print out accounts etc. and some joysticks. The trouble with these 
computers was that they tended to die after a couple of years use. But they were cheap and 
came with a few software titles."


$end


#---------------------------------------------------------------------------------------------#

$info=macplus
$bio
Apple Macintosh Plus


History and Trivia:

The Macintosh Plus was the first real improvement of the Macintosh 128 (The Macintosh 512 was 
only a Mac 128 with 512 KB RAM). It had a lot of new features: the extended ROM held the new 
version of MAC OS : enhanced graphic libraries, drivers for hard disk and external floppy disk 
units, SCSI bus and AppleTalk network and the new files manager: HFS (Hierarchical File System).

The new floppy disk unit could use double-sided 800 KB disks (compared to only one-sided 400 
KB for the 128). It has an enhanced keyboard with a numeric pad and last but not least, it 
had a SCSI 1 (1.5 MB/s) interface. This computer was replaced in 1988 by the new Macintosh 
series: the Macintosh SE and the Macintosh II.


$end

#---------------------------------------------------------------------------------------------#

$info=max
$bio
Commodore Max


History and Trivia:

Delivered in japan only?

 (vic10,ultimax,vickey prototype)

 (all modules should work with c64)

 cartridges neccessary (nothing works without cartridge)

 low cost c64

 flat design

 only 4 kbyte sram

 simplier banking chip

  no portlines from cpu

 only 1 cia6526 chip

  restore key connection?

  no serial bus

  no userport

 keyboard

  restore key in pictures!

 tape port

 2 gameports

  lightpen (port a only) and joystick mentioned in advertisement

  paddles

 cartridge/expansion port (some signals different to c64)

 no rom on board (minibasic with kernel delivered as cartridge?)


$end


#---------------------------------------------------------------------------------------------#
$info=msx
$bio
MSX 1 Class Computers

The MSX driver currently emulates the MSX1, international, UK, korean and Japanese models.


Not emulated:
Printer port, diskdrives, megaRAM, Sound Cartridge (SCC+), MSX2, etc..


Cartridge emulation:
The MSX has 64kB RAM, like most (by far) MSX1 computers. It is located in slot 3. Two 
cartridges are allowed: the first in slot 1 and the second in slot 2. So subslots aren't 
emulated (yet). 


The msx.crc file is important. The last field on every line specifies the type of ROM mapper. 
See msx.crc for more information.


Sound emulation:
The standard sound chip, the PSG (AY8910) is emulated, so is the extension that was included 
in some Konami cartridges: the SCC. The keyclick (PPI) is also emulated, as is the FM-PAC 
(you'll need the fmpac.rom of the original Panasonic FM-PAC for this). Unfortunately the 
YM2413 emulation in MAME does not emulate the volumes correctly.


Last but not least, the DAC in Konami's Synthesizer is emulated, and the SIMPL (DAC on the 
printer port). The DAC in Konami's Matjusushi is also emulated, but the driver lacks MSX2 
support.  


SRAM in cartridges:
A number of cartridges (Hydlide 2, Xanadu, The Game Master 2 and more) had on-board sram. 
This sram is automagically saved as a MEMCARD.  


Tape emulation:
Unlike other MSX emulators, the tape emulation is not done by trapping BIOS calls. In our 
opinion this is an evil kludge; apart from that, our setup does have an advantage. Tapes with 
a custom loader (using direct access to the hardware) will work fine. It is done by saving 
the tape as a .wav file. In principle, you could record a tape to .wav, and load them into 
MESS.


History and Trivia:

In the early 80's, there were a lot of home computers, Microsoft and a Japanese company 
called ASCII corporation (directed by Kay Nishi) decided then to create an industry standard 
for the home computers: MSX (for MicroSoft eXtended). The new standard was based on an 
existing computer: The Spectravideo SV 318. Microsoft designed the MSX 1 computers and the 
first version of the OS: MSX DOS 1 (which looks like earlier versions of MS DOS).


Almost all japanese and Korean computer companies made their own MSX computers (except 
parhaps NEC). Bill Gates was then very confident about the future of the MSX standard. 
Spectravideo (one of the MSX companies) made a 80 columns card and adapted CP/M on the MSX.
A lot of software(especially a lot of games from Sega, Konami, Taito, Ascii,...) and 
hardware was developed for this standard. Despite all its qualities, the MSX family didn't 
have great success in USA, however was pretty known in Europe (Netherlands and France), in 
South Americca (Brazil) and USSR. This standard was replaced in 1985 by MSX 2. 


$end

#---------------------------------------------------------------------------------------------#

$info=nes
$bio
Nintendo Entertainment System/Famicom


Usage:

Under the "Options" menu, accessible by hitting TAB, are two settings.


"Renderer" - can be set to Scanline or Experimental. 

The Scanline renderer gives the most accurate display, but can be slow. 

The Experimental option is much faster, but still needs quite a bit of work before it 
displays properly in all cases. It's best used for games with no scrolling playfields, 
like Donkey Kong, etc.


"Split-Screen fix" - defaults to off. Turn it on to see proper split screens in games 
like Kirby's Adventure and Airwolf. This will most likely go away in the future as we 
figure out how these split screens really work.


Known Issues:

The NES driver should run 99% of the images currently out there with very little problem. 
It doesn't yet support a lot of the obscure mappers used in fwNES, but this is being 
worked on. For the record, it supports mappers 1, 2, 3, 4, 5 (incomplete), 7, 8, 9 & 10 
(incomplete), 11, 15, 16, 18 (vrom probs), 25 (vrom probs), 33, 34, 64, 65, 66, 
68 (incomplete), 69 (incomplete), 71, 78, 79. Some of the mappers over 63 haven't been fully 
tested yet. See nes.crc for a partial compatibility list.

The NES driver has quite accurate sound and sample playback. For example, you can hear speech 
samples in Bayou Billy, Gauntlet, Dirty Harry, and Skate or Die that are not present in a 
few other NES emulators.

The main focus up until this point has been in getting the NES driver as accurate as 
possible. Unfortunately, the scanline rendering method is quite slow, so future efforts 
will be focusing on bringing up the speed. 

Wanted: I'd appreciate any info on some of the more obscure mappers. If you have any of this, 
please drop me a line at bradman@pobox.com


$end

#---------------------------------------------------------------------------------------------#

$info=oric1
$bio
Oric 1


History and Trivia:

This British computer was one of the most popular computers in Europe in early 80's, and a 
competitor of the Sinclair Spectrum. The two models (16 and 48) had the same technical 
characteristics, but the model 48 was sold with FORTH language. A small plotter was available 
for this computer. Note that the sound chip was the same as the one in the Amstrad CPC, 
MSX computers and Atari ST! The Oric 1's ROM was very bugged though, and it was replaced with 
the Oric Atmos.


$end

#---------------------------------------------------------------------------------------------#

$info=orica
$bio
Oric Atmos


History and Trivia:

The Oric Atmos was the successor of the Oric 1 and had almost the same characteristics. Its 
main difference with the Oric 1 was it's enhanced RAM (48 KB instead of 16 KB), the keyboard 
and the debugged ROM (the ORIC 1 had several bugs). Several peripherals were availables: 
3" floppy disk drive, a small 4 colour plotter, a speech synthesiser and a Digital/Analogue 
converter. An external interface was needed to use joysticks. 


$end

#---------------------------------------------------------------------------------------------#

$info=pc
$bio
IBM Personal Computer XT (and clones)


History and Trivia:

In early 1980, IBM decided to create a micro computer (up to this date, IBM produced only 
mini and mainframe computers), they didn't really know what they wanted and they didn't 
think for one second that producing micro computer was a profitable business! They asked 
Digital Research (the authors of CP/M) to create an operating system for their new computer.
DR was not very interested, so they approached the then small company Microsoft (at this point 
famous for it's BASIC language) to write this operating system. Microsoft wasn't capable of 
doing it themselves, so Bill Gates bought up the rights to an OS written by a small company 
called Seattle's Computers Products: QDOS (Quick and Dirty Operating System) which became 
PCDOS and later MS-DOS.


The IBM PC wasn't very powerful (and was certainly less powerful than a lot of 8 bit 
computers), the very first PC had only 16 KB RAM and no floppy disk units -- they used 
cassettes. Notice that the functions to handle the cassettes were present in the operating 
system up to MS-DOS 5. The PC was available with either CGA or MDA (on an MPA card). The CGA 
adapter actually had an RCA composite output to hook it up to your TV if you did not want the 
CGA monitor.


The IBM PC XT was the successor of the IBM PC. It's enhanced features included hard disk 
capability, more memory, and no more tape port. Perhaps because of the name and fame of IBM, 
the PC series became a standard and IBM dominated the computer market up until the end of the 
80's. Clones of the XT, such as the Tandy 1000 became commonplace by the end of the decade.


$end

#---------------------------------------------------------------------------------------------#

$info=pce
$bio
NEC PC Engine/TurboGrafx-16


Known Issues:

Preliminary...  Xevious and Raiden8x work OK.

$end

#---------------------------------------------------------------------------------------------#

$info=pdp1
$bio
DEC PDP-1


Currently emulates one image - SPACEWAR!

$end

#---------------------------------------------------------------------------------------------#

$info=pet
$bio
Commodore PET series


History and Trivia:

The Commodore PET 2001 was a great success. Three models were made : the PET 2001-8N with 8 KB 
RAM, PET 2001-16N with 16 KB RAM and the PET 2001-32N. They were conceived by Chuck Peddle who 
later founded Tandon.


The CBM PET 3032 was the successor of the PET 2001-32N (and has the same characteristics as the 
PET 2001-32N), and the predecessor of the CBM 40000 Series.


The disk drives were "Intelligent", which means that they were CPU driven (MOS 6502) and had 
internal RAM (4 KB) & ROM (16KB, which contains the DOS). The 4032 and the 4016 (the version 
of the CBM 4000 with 16 KB of RAM) were sold with a 80 column dot matrix printer (5x8 
character matrix). This printer (4022) was an Epson printer with the Commodore name on it.


The Commodore 8000 series was a "bundle". It was made up of the computer (most often the CBM 
8032, though other models were made), the 5.25" double disk drive CBM 8050 (500 KB, 77 tracks) 
and the bi-directional 132 columns, 160 CPS printer. The 8050 has two 6502's, 4 KB of RAM and 
12 KB of ROM (which contains the DOS). It was sold with Ozz - a Database, and a version of the 
spreadsheet "Visicalc".


$end


#---------------------------------------------------------------------------------------------#


$info=raaspec
$bio
RA+A Spectrum I+


Usage:

For the 8-button key mappings, see the user menu under "Keys (This Machine)".

This driver supports the LED backdrop images:

spec_bt.png

led.png


History and Trivia:

The Spectrum I+ was a modified Vectrex. It had a 32K ROM cart and 2K additional battery 
backed RAM (0x8000 - 0x87ff). PB6 was used to signal inserted coins to the VIA. The 
unit was controlled by 8 buttons (2x4 buttons of controller 1 and 2).  Each button had a 
LED which were mapped to 0xa000.  The service mode can be accessed by pressing button 8 
during startup.  As soon as all LEDs light up, press 2 and 3 without releasing 8. Then 
release 8 and after that 2 and 3. You can leave the screen where you enter ads by 
pressing 8 several times.


$end

#---------------------------------------------------------------------------------------------#

$info=spectrum
$bio
Sinclair ZX Spectrum 48k


Known Issues:

Requires full keyboard emulation. At startup, full keyboard emulation mode is enabled by 
default.  Whilst in full keyboard emulation mode, some key associated functionality may be 
disabled (like the ESC key for EXIT). The keyboard emulation mode is toggled using the 
scroll_lock key.   


$end

#---------------------------------------------------------------------------------------------#

$info=sfzch
$bio
Capcom CPS Changer


History and Trivia:

Perhaps inspired by SNK's Neo-Geo, Capcom released the Capcom Power System Changer (CPS in 
this case NOT referring to Capcom Play System) in 1994, as an attempt to sell their arcade 
games in console format.  The console basically served as an encased SuperGun (Television 
JAMMA adapter) but was wired up so coin inputs could not be added by hackers, and only the
special CPS Changer cartridge boards would work. The CPS Changer had outputs for Composite
video, S-Video and 8 channel mono audio. It's joystick (named the "CPS Fighter") had the
same connection as the Super Famicom, and was even marketed seperately for that console.


The games came as PCBs in plastic casing, and were virtually identical to their CPS-1 arcade
counterparts, though they often contained extra debugging features.  The CPS Changer was
sold as a package deal of the console itself, one CPS Fighter controller, and the Street
Fighter II Turbo game for 39,800 yen. Additional games were sold for about 20,000 yen.


The CPS Changer sold poorly though, and support was dropped in March 1996 after releasing 
the console's only unique (as in non-CPS1) title: Street Fighter Zero, for 35,000 yen.
Street Fighter Zero was a downscaled version of the CPS2 arcade version from the year prior.
It ran somewhat choppier, had a reduced colour depth, and the sounds were at a lower sample
rate.


Ten other games were released for the CPS Changer, though none have been dumped at present
(to the best of my knowledge). If/when these are dumped, support will be added for them: 

Captain Commando (1995)

Final Fight  (1994)

The King of Dragons (1995)

Knights of the Round (1995)

Muscle Bomber:The Body Explosion (1994)

Muscle Bomber Duo: Burn Up Warriors (1995)

Quiz Capcom World 2 (1994)

Street Fighter II' Champion Edition (1994)

Street Fighter II Turbo (1994, Pack-in)

Tenchi O Kurau II (1995)


$end

#---------------------------------------------------------------------------------------------#

$info=ti99_4
$bio
Texas Instruments TI-99/4 Home Computer


Known Issues:

This TI99/4 driver is preliminary and could not be tested.


History and Trivia:

The TI99/4 Home Computer was designed and built by Texas Instrument.  About
200 prototypes were built in 1978, it was first shown in June 1979, and TI
started shipping it in October 1979.  It was replaced with TI99/4a in the
summer of 1981.  It was first sold in US, then was available in Europe in
early 1981.

This computer was easy to use.  It displayed nice color graphics, and
played sound.  It was highly expandable, too.  One expansion enabled the
computer to speak.  Programs were generally on cartidges.  TI, which always
tried to keep the control of program production, put an emphasis on games,
education, and home utilities (home finance, etc.).  Incidentally, it was
the first 16-bit home computer.

The general architecture was odd.  The computer had only 256 bytes of CPU
RAM, the remaining 16kb of RAM were attached to the video processor.  It
had been designed to use some slow "GROM" cartidge, written in an
interpreted language, "GPL".

Due to these poor designing and programming choices, the computer was slow.
The keyboard was uneasy to use, and there was serious bugs in ROMs.  Also,
it wasn't until november 1980 that TI could build a TV modulator to attach
the computer to a TV instead of a monitor.  Worse, the computer was awfully
expensive for a home computer (more than $1000 with the monitor, more than
$500 with the modulator).  Unsurprisingly, it is estimated that only a few
dozen thousand units were sold.

The design of TI99/4 caused many headaches to TI engineers.  It was first
designed as a console, then an inexpensive home computer (which explains
its slowness and kludgy design), then a hybride (with remote I/R joysticks
and keypads - which were abandonned at the last minute - and a cartidge
port).  It was intended to use a TI-designed processor, tms9985, but the
processor was never actually produced, so engineers had to use a
software-compatible, high-end (in 1979) tms9900 with tons of glue logic.
Note that the processor software design was remarkably weird (no stack, no
on-chip data register).


Wanted:

If you have a TI99/4 ROM image, or if you know how the extra system GROM
maps in the memory space, please mail me at pytheas@club-internet.fr

$end

#---------------------------------------------------------------------------------------------#

$info=ti99_4a
$bio
Texas Instruments TI-99/4a Home Computer


Known Issues:

Requires full keyboard emulation. At startup, full keyboard emulation mode is enabled by default. Whilst in full keyboard emulation mode, some key associated functionality may be disabled (like the ESC key for EXIT). The keyboard emulation mode is toggled using the scroll_lock key.


Usage:

This TI99/4a driver offers a high level of compatibility.  It currently
supports V9t9-format cart images and up to SSSD disk images.  Speech
synthesis is partially suported.

Loading a cart:

No cartidge is required, as TI99/4a has a built-in small basic interpreter.

V9t9-format cart images are split into up to 3 files.  You have to put the
GROM in first position, the CPU ROM in second position, and the second page
of CPU ROM in third position.

If the cart is GROM-less and you are using a command-line interface, you
need to use a place-holder, and type something like "mess /dev/null
cartC.bin" under *NIX, and "mess Dummy cartC.bin", where Dummy is an empty
or all-0s file, under DOS.


History and Trivia:

The TI99/4a Home Computer was a TI99/4 with improved keyboard, revised
ROMs, and an additionnal graphics mode.  It was officially introduced in
June 1981, and was retired in late 1983.

TI99/4a was quite successful in Europe and US (possibly hundreds of
thousand units built).  In 1983, though, competition on the home computer
market was so harsh that TI had to cut down the price of TI99/4a to less
than $100, while suffering heavy losses.  So, by the end of 1983, TI had
abandonned TI99/4a, its prototype successors, and withdrawn from the home
computer market.

$end

#---------------------------------------------------------------------------------------------#

#$info=ti99_2
#$bio
#Texas Instruments TI-99/2 BASIC Computer


#Known Issues:

#This TI99/2 driver is preliminary and could not be tested.  (It may work,
#it may not work.)


#History and Trivia:

#The TI99/2 BASIC Computer was an attempt at producing a cheap ($100)
#computer.  TI started designing it in the summer of 1982, it was first
#introduced in January 1983, and it was abandonned, before entering
#production, by April 1983.

#It featured a TMS9995 microprocessor (with on-line timer and 256-byte RAM),
#4kb of RAM, 24kb (or 32kb) of ROM, a B&W character-based display.  There
#was no sound generator.  It was mostly incompatible with TI99/4(a), but
#used the same Basic syntax and file format.

#The computer was obviously unattractive.  On the other hand, it would have
#been cheap, fairly fast for its time, and easy to program in both BASIC and
#assembly.

#Moreover, the expansion port of TI99/2 carried every bus signal, and even
#allowed to disable the system ROMs and use one's own ROMs instead, so this
#computer could have been a hobbyist's dream.


#Wanted (dead or alive):
#If you have an actual TI99/2 or TI99/2 ROM image at hand, please mail me at
#pytheas@club-internet.fr

#$end

#---------------------------------------------------------------------------------------------#

$info=trs80
$bio
Tandy/Radio Shack TRS-80 Model I


Usage:

keyboard - relatively close to the original layout.

Take a look into the "Options" menu, accessible by hitting TAB, and choose "Keys (This 
Machine)" to  find out more about the key mapping.


cassette - emulation of virtual tapes supported.

Use SYSTEM or CLOAD commands to read images.

SYSTEM supports 6 character filenames and loads the corresponding FILENM.CAS image.

CLOAD loads a file named BASIC(N).CAS, where (N) is the character you supplied 
(e.g. CLOAD"M" loads BASICM.CAS)


floppies - emulation of virtual floppy discs supported. 

Use a NEWDOS/80 boot disk for drive 0 and set up correct PDRIVE parameters for the other drives. If only drives 0 to 2 are used they can be double sided by interpreting drive select 3 as head select bit.


Under the "Options" menu, accessible by hitting TAB, there are three settings.

"Floppy Disc Drives"  - enable or disable floppy disc controller.

"Video RAM"           - enable upper case only or upper/lower font.

"Virtual E000-EFFF"   - enable 4K Extension ROM or make it RAM.


The TRS-80 driver should run most of the known programs out there. It supports a WD 179x 
floppy disc controller with up to four virtual floppy disc drives contained in image files.


History and Trivia:

The Tandy TRS-80 model 1 was the first member of one of the most famous computer families. It 
is one of the first home computers and was launched at the same time as such famous computers 
as the Mits Altair or the Apple 1. It used a black & white TV set without a tuner as monitor. 
The earliest models used a poor basic called Basic Level 1 (the basic and the OS fits in the 4 
KB ROM !) which had no instruction to save the program! It was replaced later with the Basic 
Level 2 which needs a 12 KB ROM. To offset its poor characteristics, Tandy developed a device 
called the Expansion Interface which brought a lot of new features: 16, 32 or 48 KB RAM, two 
tape unit connectors, a printer port, a floppy disk controller, a serial port and a real 
time clock.


When it was connected to a floppy disk unit, the TRS 80 used the TRS DOS operating system, it 
was pretty bugged and most of the TRS80 users prefered NEW DOS, it is an operating system 
done by a third-party company called Apparat. This OS was the real TRS 80 operating system.


The Model 1 was followed with the TRS 80 model II and model III (the model III had almost the 
same characteristics as the model I).



$end

#---------------------------------------------------------------------------------------------#

$info=vectrex
$bio
GCE Vectrex


Usage:

Though the Vectrex emulation can be loaded with a cartridge image, starting without one will
allow you to access the built-in game Minestorm (provided the system.img bios is present).


Known Issues:

No light pen support.


Almost every cartridge is playable, except those requiring the light pen. See vectrex.crc for 
a current compatibility list. Overlays are supported in .png format, using the same name as 
the cartridge image being loaded. Place overlays in the artwork directory. The overlay for
the built in minestorm game must be named "mine.png" to load when no image is selected.


History and Trivia:

The Vectrex was released in the US late in 1982 by General Consumer Electric (GCE) at a 
suggested retail price of $199. The Vectrex differed from other consoles in that it had 
it's own built in nine inch by eleven inch vector monitor, and thus didn't require (or 
even allow) the use of a television set. The system even contained a built in game, the 
Asteroids-like "Minestorm". 


The monochrome Vectrex used screen overlays to give the illusion of colour, and also to 
reduce the severity of the inherent flickering caused by the vector monitor.


In 1983, GCE was merged into Milton Bradley, who expanded the Vectrex's market to include 
Europe. As the video game market declined and then crashed, the Vectrex exited the market 
in early 1984. The rights to the system reverted to it's developers, Smith Engineering. 


Smith Engineering briefly considered designing a handheld version of the device in 1988, 
though the success of the Nintendo Gameboy made such a project too risky. In the mid-1990s, 
Smith Engineering condoned the duplication of the Vectrex system image and cartridges for 
non-commercial uses.


$end

#---------------------------------------------------------------------------------------------#

$info=vic20
$bio
Commodore VIC20 and VC20


Cartridge Usage:

Cartridges may have any of the following extensions: .bin .rom .a0 .20 .40 .60 .prg
Files with boot-sign in it are recognised as roms. Some cartridges require more than one 
image (for example, defender.60 defender.a0).


.20 files loaded at 0x2000 

.40 files loaded at 0x4000

.60 files loaded at 0x6000

.a0 files loaded at 0xa000

.prg files loaded at address in its first two bytes

.bin and .rom files are loaded at 0x4000 when 0x4000 bytes long, 
otherwise they are loaded at 0xa000

Note that .prg files are assigned to the quickloader (so you have to use 
the -cart switch when loading rom images).


Cassette Usage:

Cassette images with the .wav or .prg extensions as well as multiple .prg files 
contained within a zip file can be loaded. Zip files must be placed in the current directory, 
and the contained prg files are played in sequential order.


The format for WAVs are: 
8 bit (16 bit may work, but hasn't been tested), mono, 12500 Hz minimum. This has the same 
problems as an original Datasette tape drive (the tone head must be adjusted to get working 
(no load error...) wav-files)


Note that tape volume is DAC1 volume within the MESS UI On Screen Display Options (accessed
with the tilde (~) key in the DOS version.


Within the emulation, use LOAD or LOAD"" or LOAD"",1 for loading normal programs. Use 
LOAD"",1,1 for loading programs to a special address.


Diskette Usage:

Disk drives are simulated at the moment, and only file loads from drive 8 and 9 
are implemented. You can load a program file from the rom directory (*.prg,*.p00)
(This must NOT be specified on commandline, start the vc20 emulation with no images specified)
 

You can also load a file from a d64 image (The directory command LOAD"$",8 is supported when 
using d64 images).


Within the emulation, basic programs can be loaded with: 

LOAD"filename",8 


Machine language programs can be loaded to their address with: 

LOAD"filename",8,1


When a program is loaded, type RUN or the appropriate SYS call to start it. 


Note that several programs rely on more features not currently emulated (such as 
loading other file types, writing...) Some games also rely on starting programs in the 
floppy drive's proccessor (and therefore cpu level emulation of the 1541 is needed).


Quickloader Usage:

A quickloader is available via the f8 key. It supports program image files 
with the .prg extension. This loads the program into memory and sets the program end 
pointer. It works with most programs. The program can be started by entering "RUN" in 
the emulation.


Miscellaneous Usage Notes:

Note that the pixel ratio for the PAL version is about 13/10 ! Resolution 1024x768 is good, 
but only part of the screen is filled. 800x600 is acceptable. Better to define own display 
mode (when the graphic driver supports this). For an acceptable display under XMESS, you can 
use the following switches: 

-scalewidth 3 -scaleheight 2


If you run into difficulty, be sure to start the emulation with the -log switch, and look into
the error.log file that is created in your mess directory.


See "Keys (This Machine)" in the TAB/Options menu for key assignments. Some key usages of note: 

stop-restore in many cases will cause the prompt to reappear.

shift-cbm switches between upper-only and normal character set (if wrong characters are on 
screen this often can help)

run (shift-stop) load and start program from tape.


The emulated light pen uses Paddle 3 x-axe and Paddle 4 y-axe.


While a normal or well written program will work regardless of the video system (PAL or 
NTSC), if the screen is too wide right or low, or the screen doesn't fit in visible 
area or gameplay is too fast try using the pal (vc20) version, instead.


Known Issues:

Some PC-Keyboards do not behave well when two or more special keys are pressed at the same 
time (with my keyboard printscreen clears the pressed pause key!)

The timer system only 98% accurate.

The serial bus allows simple disk support, but no printer or other devices at present.

No userport, no rs232/v.24 interface.

No special expansion modules like ieee488 interface are supported in the expansion port.


Image compatibility is quite high, see vic20.crc for a partial list. The emulation features a
rasterline based video system which should be enough for all vic20 games and programs. The 
emulation supports the keyboard, as well as joysticks, paddles and lightpen, via the emulated
gameport, and simple Disk and Tape support. The expansion slot supports ram and rom 
cartridges, though not special expansion modules (see known issues). For a more complete vic20 
emulation, take a look at the very good vice emulator.


History and Trivia:

The Commodore VIC 20 was the successor of the CBM PET. It was designed by Bob Yannes at CBM, 
he later designed the SID chip for the C64 and then went to Ensoniq to design synthesisers. 
The VIC 20 used the same microprocessor and the same Basic language as the PET. It was very 
popular in the early 80's. Commodore sold more than 1 million of this computer! A great range 
of peripherals were developed for this computer as well as a lot of software. When it became 
obsolete, Commodore replaced it by the Commodore 16 which had no success.

Note that its name came from the name of its video chip VIC (Video Interface Chip) and 
its memory size : 5 KB RAM + 15 KB ROM = 20 KB ! 


$end

#---------------------------------------------------------------------------------------------#

$info=zx80
$bio
Sinclair ZX 80


History and Trivia:

The Sinclair ZX 80 is the ancestor of the Sinclair ZX 81. It had a short life (less than one 
year) and was replaced with the ZX 81 which was more integrated and cheaper.


$end

#---------------------------------------------------------------------------------------------#

$info=zx81
$bio
Sinclair ZX 81 / Timex Sinclair 1000


History and Trivia:

The Sinclair ZX 81 was the successor of the ZX 80. It had the same characteristics as the 
ZX 80, it's main difference (except for the colour) was its higher level of integration: the 
ZX 80 used about 12 chips which had been replaced with a ULA in the ZX 81. This computer was 
very successful in Europe at the beginning of the 80's. A large range of peripherals were 
developed for the ZX-81, among them: 3.5" floppy disk units, high resolution graphic cards, 
RS232 or Centronics interfaces, and RAM extensions. The ZX 81 was sold as the Timex-Sinclair 
1000 in the USA. 


$end

#---------------------------------------------------------------------------------------------#
